<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: Collatz.cpp File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">Collatz.cpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;cassert&gt;</code><br />
<code>#include &lt;iostream&gt;</code><br />
<code>#include &lt;sstream&gt;</code><br />
<code>#include &lt;string&gt;</code><br />
<code>#include &lt;tuple&gt;</code><br />
<code>#include &lt;utility&gt;</code><br />
<code>#include &lt;fstream&gt;</code><br />
<code>#include &quot;<a class="el" href="Collatz_8hpp_source.html">Collatz.hpp</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for Collatz.cpp:</div>
<div class="dyncontent">
<div class="center"><img src="Collatz_8cpp__incl.png" border="0" usemap="#Collatz_8cpp" alt=""/></div>
<map name="Collatz_8cpp" id="Collatz_8cpp">
<area shape="rect" id="node9" href="Collatz_8hpp.html" title="Collatz.hpp" alt="" coords="146,80,234,107"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a807702752b3ea0d5c88ae174c61dca23"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="Collatz_8cpp.html#a807702752b3ea0d5c88ae174c61dca23">CACHE_RANGE</a>&#160;&#160;&#160;1000</td></tr>
<tr class="separator:a807702752b3ea0d5c88ae174c61dca23"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a2772f8a734aeab48332eb3b282f991ba"><td class="memItemLeft" align="right" valign="top">pair&lt; int, int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="Collatz_8cpp.html#a2772f8a734aeab48332eb3b282f991ba">collatz_read</a> (const string &amp;s)</td></tr>
<tr class="separator:a2772f8a734aeab48332eb3b282f991ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1fd62f9e2b2d968d8fb3a0dcd218fc2c"><td class="memItemLeft" align="right" valign="top">tuple&lt; int, int, int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="Collatz_8cpp.html#a1fd62f9e2b2d968d8fb3a0dcd218fc2c">collatz_eval</a> (const pair&lt; int, int &gt; &amp;p)</td></tr>
<tr class="separator:a1fd62f9e2b2d968d8fb3a0dcd218fc2c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf863656dbf3c0d5938148064dbe9650"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="Collatz_8cpp.html#aaf863656dbf3c0d5938148064dbe9650">cycleSolve</a> (int i, int j)</td></tr>
<tr class="separator:aaf863656dbf3c0d5938148064dbe9650"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af259cc6d37bf5efb1a576b7cc850ae36"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="Collatz_8cpp.html#af259cc6d37bf5efb1a576b7cc850ae36">collatzSolve</a> (int i)</td></tr>
<tr class="separator:af259cc6d37bf5efb1a576b7cc850ae36"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acadb402e715fd843d070857520406666"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="Collatz_8cpp.html#acadb402e715fd843d070857520406666">mCacheSolve</a> (int i, int j, int temp)</td></tr>
<tr class="separator:acadb402e715fd843d070857520406666"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1671e1a9336aa13a94ca7701d5dcb37e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="Collatz_8cpp.html#a1671e1a9336aa13a94ca7701d5dcb37e">collatzLoop</a> (int i, int j)</td></tr>
<tr class="separator:a1671e1a9336aa13a94ca7701d5dcb37e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a45d45bf5c627b1ab1eb5ff9c9d4c1f8e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="Collatz_8cpp.html#a45d45bf5c627b1ab1eb5ff9c9d4c1f8e">getMCash</a> ()</td></tr>
<tr class="separator:a45d45bf5c627b1ab1eb5ff9c9d4c1f8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab6092110b1525ab0de679ca0b20e13eb"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="Collatz_8cpp.html#ab6092110b1525ab0de679ca0b20e13eb">collatz_print</a> (ostream &amp;sout, const tuple&lt; int, int, int &gt; &amp;t)</td></tr>
<tr class="separator:ab6092110b1525ab0de679ca0b20e13eb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab43d648b4711e8c591a9739f196f1312"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="Collatz_8cpp.html#ab43d648b4711e8c591a9739f196f1312">collatz_solve</a> (istream &amp;sin, ostream &amp;sout)</td></tr>
<tr class="separator:ab43d648b4711e8c591a9739f196f1312"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a6727a38d4435430d267e53025ba09c8e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="Collatz_8cpp.html#a6727a38d4435430d267e53025ba09c8e">lCache</a> [1000000]</td></tr>
<tr class="separator:a6727a38d4435430d267e53025ba09c8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a12a8303ee13f3fd30bcd6026d4a3ff3f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="Collatz_8cpp.html#a12a8303ee13f3fd30bcd6026d4a3ff3f">mCache</a> [1000]</td></tr>
<tr class="separator:a12a8303ee13f3fd30bcd6026d4a3ff3f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="a807702752b3ea0d5c88ae174c61dca23"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a807702752b3ea0d5c88ae174c61dca23">&#9670;&nbsp;</a></span>CACHE_RANGE</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define CACHE_RANGE&#160;&#160;&#160;1000</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a1fd62f9e2b2d968d8fb3a0dcd218fc2c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1fd62f9e2b2d968d8fb3a0dcd218fc2c">&#9670;&nbsp;</a></span>collatz_eval()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">tuple&lt;int, int, int&gt; collatz_eval </td>
          <td>(</td>
          <td class="paramtype">const pair&lt; int, int &gt; &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td>pair of ints </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>a tuple of three ints </dd></dl>

</div>
</div>
<a id="ab6092110b1525ab0de679ca0b20e13eb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab6092110b1525ab0de679ca0b20e13eb">&#9670;&nbsp;</a></span>collatz_print()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void collatz_print </td>
          <td>(</td>
          <td class="paramtype">ostream &amp;&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const tuple&lt; int, int, int &gt; &amp;&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>print three ints </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">an</td><td>ostream </td></tr>
    <tr><td class="paramname">a</td><td>tuple of three ints </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a2772f8a734aeab48332eb3b282f991ba"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2772f8a734aeab48332eb3b282f991ba">&#9670;&nbsp;</a></span>collatz_read()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">pair&lt;int, int&gt; collatz_read </td>
          <td>(</td>
          <td class="paramtype">const string &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>read two ints </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td>string </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>a pair of ints </dd></dl>

</div>
</div>
<a id="ab43d648b4711e8c591a9739f196f1312"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab43d648b4711e8c591a9739f196f1312">&#9670;&nbsp;</a></span>collatz_solve()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void collatz_solve </td>
          <td>(</td>
          <td class="paramtype">istream &amp;&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ostream &amp;&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">an</td><td>istream </td></tr>
    <tr><td class="paramname">an</td><td>ostream </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a1671e1a9336aa13a94ca7701d5dcb37e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1671e1a9336aa13a94ca7701d5dcb37e">&#9670;&nbsp;</a></span>collatzLoop()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int collatzLoop </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>j</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Basic collatz loo`for a given range </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">two</td><td>ints </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>a single int </dd></dl>

</div>
</div>
<a id="af259cc6d37bf5efb1a576b7cc850ae36"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af259cc6d37bf5efb1a576b7cc850ae36">&#9670;&nbsp;</a></span>collatzSolve()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int collatzSolve </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>i</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>solve cycle length for a single int </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td>single int </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>a single int </dd></dl>

</div>
</div>
<a id="aaf863656dbf3c0d5938148064dbe9650"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaf863656dbf3c0d5938148064dbe9650">&#9670;&nbsp;</a></span>cycleSolve()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int cycleSolve </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>j</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>solve max cycle length for specified range </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td>pair of ints </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>a single int </dd></dl>

</div>
</div>
<a id="a45d45bf5c627b1ab1eb5ff9c9d4c1f8e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a45d45bf5c627b1ab1eb5ff9c9d4c1f8e">&#9670;&nbsp;</a></span>getMCash()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void getMCash </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>builds meta cash from mCash.txt </p>

</div>
</div>
<a id="acadb402e715fd843d070857520406666"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acadb402e715fd843d070857520406666">&#9670;&nbsp;</a></span>mCacheSolve()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mCacheSolve </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>j</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>temp</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>solves cycle length for a given range provided that the meta cache can be used </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">three</td><td>ints </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>a single int </dd></dl>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="a6727a38d4435430d267e53025ba09c8e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6727a38d4435430d267e53025ba09c8e">&#9670;&nbsp;</a></span>lCache</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int lCache[1000000]</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a12a8303ee13f3fd30bcd6026d4a3ff3f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a12a8303ee13f3fd30bcd6026d4a3ff3f">&#9670;&nbsp;</a></span>mCache</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mCache[1000]</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
